#!/bin/bash
# Expects 1 argument - time to wakeup in the format HH:MM
#
BOOTFLAGFILE=/etc/bootflag
#
echo "`date` sleeprtc: Executing now" >> /var/log/logrtc.log
#
hourtowake=$1
#
if [ "$1" == "" ]
then
    hourtowake="06:00"
fi
#
timenow=`date +"%H:%M"`
#
if [ $timenow \> $hourtowake ]
then
    timetowake=`date -d "tomorrow $hourtowake" +"%s"`
else
    timetowake=`date -d "$hourtowake" +"%s"`
fi
#
# stop running processes
/etc/stopproc.sh
#
echo "`date` sleeprtc: Going asleep now, scheduling wake for local time: `date -d @$timetowake`" >> /var/log/logrtc.log

/usr/sbin/vbetool vbestate save > /tmp/videostate
/usr/sbin/rtcwake -t $timetowake -m mem
/usr/sbin/vbetool vbestate restore < /tmp/videostate
/bin/sleep 60

echo "`date` sleeprtc: Woken up from sleep, rebooting now" >> /var/log/logrtc.log
echo "S" > $BOOTFLAGFILE
/sbin/reboot

#################################################################
#NOTES:
# 1) The call to save the vbestate produces the following output
#    on stderr:     Allocated buffer at 0x2010 (base is 0x0)
#                   ES: 0x0201 EBX: 0x0000               
#
# 2) The call to restore the vbestate produces the following output
#    on stderr:     Function not supported
#
# These errors do not appear to affect performance
#################################################################


